﻿using UnityEngine;
public class BubbleProjectileBehaviour : MonoBehaviour
{
    int lifeInBounces;
    public SpriteRenderer sr;
    public Rigidbody2D rb;
    AudioSource audio;

    void Start()
    {
        audio = gameObject.AddComponent<AudioSource>();

        lifeInBounces = Random.Range(1, 100);
        RandomColor();
    }

    void RandomColor()
    {
        sr.color = new Color(Random.Range(0f, 1f), Random.Range(0f, 1f), Random.Range(0f, 1f), Random.Range(0f, 1f));
    }

    void OnCollisionEnter2D(Collision2D other)
    {
        lifeInBounces--;

        if(other.gameObject.TryGetComponent<PhysicalBehaviour>(out var physicalBehaviour) && other.collider.gameObject.layer == 9)
        {
            var r = Random.Range(1, 10);
            switch (r)
            {
                case 1:
                    physicalBehaviour.MakeWeightless();
                    break;
                case 2:
                    physicalBehaviour.charge += Random.Range(1f, 10f);
                    break;
                case 3:
                    physicalBehaviour.Ignite();
                    break;
                case 4:
                    physicalBehaviour.rigidbody.sharedMaterial = rb.sharedMaterial;
                    break;
                case 5:
                    physicalBehaviour.spriteRenderer.color = new Color(Random.Range(0f, 1f), Random.Range(0f, 1f), Random.Range(0f, 1f), Random.Range(0f, 1f));
                    break;
                case 6:
                    physicalBehaviour.TrueInitialMass *= Random.Range(-10f, 10f);
                    break;
                case 7:
                    physicalBehaviour.Temperature = Random.Range(0f, 10000f);
                    break;
                case 8:
                    ExplosionCreator.Explode(physicalBehaviour.transform.position, Random.Range(1f, 5f));
                    physicalBehaviour.Disintegrate();
                    break;
                case 9:
                    if (other.collider.gameObject.TryGetComponent<LimbBehaviour>(out var limb))
                    {
                        foreach (var limbs in limb.Person.Limbs)
                            limbs.BreakBone();
                    }
                    break;
                case 10:
                    physicalBehaviour.burnIntensity += Random.Range(0.25f, 1f);
                    break;
            }
        }

        RandomColor();
        audio.pitch = Random.Range(0.5f, 1.5f);
        audio.PlayOneShot(ModResources.popSFX);

        if(lifeInBounces <= 0)
        {
            ExplosionCreator.Explode(transform.position, rb.velocity.magnitude);
            Destroy(gameObject);
        }
    }
}