﻿using UnityEngine;

public class BulletProjectileBehaviour : MonoBehaviour
{
    float t = 0;
    public Rigidbody2D rb;

    AudioSource audio;

    BallisticsEmitter Ballistics;
    Transform muzzleTransform;
    ParticleSystem flash;
    AudioClip[] ShotSounds;
    GameObject BaseGun;
    FirearmBehaviour firearm;
    PhysicalProperties prop;

    public void Start()
    {
        ModAPI.CreateParticleEffect("FuseBlown", transform.position);

        BaseGun = ModAPI.FindSpawnable("Pistol").Prefab;
        firearm = BaseGun.GetComponent<FirearmBehaviour>();

        Ballistics = new BallisticsEmitter(this, firearm.Cartridge);
        Ballistics.LayersToHit = BaseGun.GetComponent<FirearmBehaviour>().LayersToHit;
        muzzleTransform = Instantiate(Resources.Load<GameObject>("Prefabs/MuzzleSmoke"), transform).transform;
        flash = muzzleTransform.GetComponentInChildren<ParticleSystem>();
        audio = gameObject.AddComponent<AudioSource>();
        audio.volume = 0.75f;
        audio.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
        audio.outputAudioMixerGroup = Global.main.SoundEffects;

        ShotSounds = firearm.ShotSounds;
    }

    public void Update()
    {

        t += Time.deltaTime * Random.Range(0.25f, 1.25f); ;
        if (t >= 0.2f)
        {
            bang();
            t = 0f;
        }
    }

    public void bang()
    {
        if (UserPreferenceManager.Current.TracerBullets)
        {
            Ballistics.MaxRange = Mathf.Clamp(firearm.Cartridge.StartSpeed / 4f, 4f, 8f);
            Ballistics.DoTraversal = true;
        }
        else
        {
            Ballistics.MaxRange = 1000f;
            Ballistics.DoTraversal = false;
        }

        var barrelPos = transform.TransformPoint(new Vector3(0.25f, 0.075f));
        var barrelDir = transform.TransformDirection(Vector3.right);

        Ballistics.Emit(barrelPos, barrelDir);

        ExplosionCreator.CreatePulseExplosion(barrelPos, Ballistics.Cartridge.Recoil / 25f, Ballistics.Cartridge.Recoil / 3f, false);
        CameraShakeBehaviour.main.Shake(Ballistics.Cartridge.ImpactForce * firearm.BulletsPerShot, barrelPos);
        muzzleTransform.localScale = Vector3.one * Mathf.Clamp(Mathf.Pow(Ballistics.Cartridge.Damage * firearm.BulletsPerShot, 0.6f) / 4f, 0.25f, 2.2f);
        muzzleTransform.localScale = new Vector3(this.transform.lossyScale.x * muzzleTransform.localScale.x, muzzleTransform.localScale.y, muzzleTransform.localScale.z);
        muzzleTransform.position = barrelPos;
        muzzleTransform.right = barrelDir;
        audio.PlayOneShot(ShotSounds[Random.Range(0, ShotSounds.Length - 1)]);
        flash.Play();
    }

    public void OnCollisionEnter2D(Collision2D other)
    {
        ExplosionCreator.Explode(transform.position, 2f);
        Destroy(gameObject);
    }
}
