﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static string ModTag = " [TZMWW]";

        public static void Main()
        {
            //1.0

            //Hell Shotgun
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Hell Shotgun" + ModTag,
                NameToOrderByOverride = "Shotgun 2",
                DescriptionOverride = "Completely original idea. \n\nTap activate to fire.\nHold the activation key to fire the hook.\nRelease the key to retract it.",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/Hell Shotgun thumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Hell Shotgun.png");
                    foreach(var col in Instance.GetComponents<Collider2D>())
                        Destroy(col);

                    Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { new Vector3(-0.4f, -0.05f) };

                    var a = Instance.AddComponent<PolygonCollider2D>();
                    a.SetPath(0, new Vector2[]
                    {
                        new Vector2(0.5f, 0.075f),
                        new Vector2(-0.35f, 0.075f),
                        new Vector2(-0.5f, -0.075f),
                        new Vector2(0.3f, 0.02f)
                    });

                    GameObject hook = ModAPI.CreatePhysicalObject("hook", ModAPI.LoadSprite("sprites/Hell Shotgun Hook.png"));
                    hook.transform.parent = Instance.transform;
                    hook.transform.localScale = Vector3.one;
                    hook.transform.localPosition = new Vector3(0.235f, -0.015f);

                    var f = hook.AddComponent<BoxCollider2D>();

                    var phys = hook.GetComponent<PhysicalBehaviour>();

                    phys.TrueInitialMass = 0.3f;

                    var prop = phys.Properties;
                    prop.Sharp = true;
                    prop.SharpAxes = new SharpAxis[] { new SharpAxis(Vector2.right, -0.1f, 0.23f, false, true) };

                    FixedJoint2D joint = hook.AddComponent<FixedJoint2D>();
                    joint.connectedBody = Instance.GetComponent<Rigidbody2D>();

                    if (Instance.GetComponent<AfterFirstSpawn>() == null)
                    {
                        Instance.AddComponent<AfterFirstSpawn>();
                        Instance.AddComponent<HellShotgunBehaviour>();
                    }

                }
            });

            //Bubble Cannon
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                NameOverride = "Rainbow Cannon" + ModTag,
                NameToOrderByOverride = "Cannon",
                DescriptionOverride = "Fires randomly colored balls that bounce, applying a random effect to anything hit, until eventually exploding.\n\nthis gun is homosexual (real)",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/Rainbow Cannon thumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Rainbow Cannon.png");

                    foreach (var col in Instance.GetComponents<Collider2D>())
                        Destroy(col);

                    var a = Instance.AddComponent<BoxCollider2D>();
                    a.offset = new Vector2(0.04f, 0.07f);
                    a.size = new Vector2(0.8f, 0.6f);
                    var b = Instance.AddComponent<BoxCollider2D>();
                    b.offset = new Vector2(-0.45f, 0.1f);
                    b.size = new Vector2(0.24f, 0.42f);
                    var c = Instance.AddComponent<BoxCollider2D>();
                    c.offset = new Vector2(-0.3f, -0.3f);
                    c.size = new Vector2(0.25f, 0.14f);
                    var d = Instance.AddComponent<BoxCollider2D>();
                    d.offset = new Vector2(0.5f, 0f);
                    d.size = new Vector2(0.15f, 0.26f);

                    Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { new Vector3(-0.25f, -0.3f) };

                    var launcher = Instance.GetComponent<ProjectileLauncherBehaviour>();
                    launcher.projectileAsset = null;
                    var bub = new GameObject("Bubble");
                    launcher.projectilePrefab = bub;
                    launcher.barrelPosition = new Vector2(0.6f, 0f);

                    launcher.OnLaunch += (sender, bubble) =>
                    {
                        var rad = bubble.AddComponent<CircleCollider2D>();
                        rad.radius = 0.15f;

                        foreach (var col in Instance.GetComponents<Collider2D>())
                            Physics2D.IgnoreCollision(col, rad);

                        var sprite = bubble.AddComponent<SpriteRenderer>();
                        sprite.material = ModAPI.FindMaterial("VeryBright");
                        sprite.sprite = ModResources.ballSprite;
                        var rb = bubble.AddComponent<Rigidbody2D>();

                        rb.AddForce((Instance.transform.right * Instance.transform.localScale.x) * Random.Range(1f, 10f), ForceMode2D.Impulse);

                        var mat = new PhysicsMaterial2D();
                        mat.bounciness = 1.1f;
                        mat.friction = 0f;
                        rb.sharedMaterial = mat;
                        var proj = bubble.AddComponent<BubbleProjectileBehaviour>();
                        proj.sr = sprite;
                        proj.rb = rb;
                    };

                }
            });

            //BULLET
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "BULLET" + ModTag,
                    DescriptionOverride = "Fires GUNS",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/BULLET thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach(var col in Instance.GetComponents<Collider2D>())
                            Destroy(col);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/BULLET.png");
                        Instance.AddComponent<BoxCollider2D>();

                        Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { };

                        var launcher = Instance.GetComponent<ProjectileLauncherBehaviour>();
                        launcher.projectileAsset = null;
                        var gun = new GameObject("gun");
                        launcher.projectilePrefab = gun;
                        launcher.barrelPosition = new Vector2(0.6f, 0f);

                        launcher.OnLaunch += (sender, pow) =>
                        {
                            var rad = pow.AddComponent<CircleCollider2D>();
                            rad.radius = 0.05f;

                            foreach (var col in Instance.GetComponents<Collider2D>())
                                Physics2D.IgnoreCollision(col, rad);

                            var sprite = pow.AddComponent<SpriteRenderer>();
                            sprite.sprite = ModResources.gunSprite;

                            var rb = pow.AddComponent<Rigidbody2D>();
                            rb.gravityScale = 0.5f;
                            rb.AddTorque(0.75f);
                            rb.AddForce(pow.transform.right * 10f, ForceMode2D.Impulse);

                            var proj = pow.AddComponent<BulletProjectileBehaviour>();
                            proj.rb = rb;
                        };
                    }
                });

            //Nailcannon
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Nailcannon" + ModTag,
                    DescriptionOverride = "A powerful weapon that fires a spinning nail that causes entities to bleed out, and then pressurizes it. \n\n <b>This'll be buggy</b>",
                    NameToOrderByOverride = "Crossbow 2",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/Nailcannon thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (var col in Instance.GetComponents<Collider2D>())
                            Destroy(col);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Nailcannon.png");
                        var poly = Instance.AddComponent<PolygonCollider2D>();
                        poly.SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.25f, 0.075f),
                            new Vector2(-0.575f, 0f),
                            new Vector2(-0.575f, -0.125f),
                            new Vector2(0.5f, -0.035f),
                            new Vector2(0.575f, 0.075f)
                        });

                        Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { new Vector3(-0.165f, -0.05f) };

                        var launcher = Instance.GetComponent<ProjectileLauncherBehaviour>();
                        launcher.projectileAsset = null;
                        launcher.projectilePrefab = new GameObject();
                        launcher.barrelPosition = new Vector2(0.575f, 0.025f);

                        launcher.OnLaunch += (sender, pow) =>
                        {
                            var nail = ModAPI.CreatePhysicalObject("Nail", ModResources.nailSprite);

                            foreach (var col in nail.GetComponents<Collider2D>())
                                Destroy(col);

                            nail.GetComponent<PhysicalBehaviour>().Properties.Sharp = true;
                            nail.GetComponent<PhysicalBehaviour>().Properties.SharpAxes = new SharpAxis[] { new SharpAxis(Vector2.right, -0.045f, 0.3f, true, false) };
                            nail.transform.position = pow.transform.position;
                            nail.transform.rotation = pow.transform.rotation;
                            nail.transform.localScale = pow.transform.localScale;
                            var box = nail.AddComponent<BoxCollider2D>();
                            box.size = new Vector2(0.6f, 0.025f);

                            nail.GetComponent<Rigidbody2D>().AddForce(pow.transform.right * 15f, ForceMode2D.Impulse);

                            foreach (var col in Instance.GetComponents<Collider2D>())
                                Physics2D.IgnoreCollision(col, box);

                            var proj = nail.AddComponent<NailProjectileBehaviour>();

                            Destroy(pow);
                        };
                    }
                });
        }

        public static void OnLoad()
        {
            ModResources.harpoonLaunchSFX = ModAPI.LoadSound("sfx/harpoonLaunch.wav");
            ModResources.harpoonReloadSFX = ModAPI.LoadSound("sfx/harpoonReload.wav");
            ModResources.popSFX = ModAPI.LoadSound("sfx/pop.wav");

            ModResources.ballSprite = ModAPI.LoadSprite("sprites/Ball.png");
            ModResources.nailSprite = ModAPI.LoadSprite("sprites/Nailcore.png");
            ModResources.nailspinSprite = ModAPI.LoadSprite("sprites/Nailspin.png");
            ModResources.gunSprite = ModAPI.LoadSprite("sprites/GunBullet.png");
        }
    }
}